package com.ejie.ab63.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab63.dao.OtrasDependenciasViviendaDao;
import com.ejie.ab63.model.OtrasDependenciasVivienda;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * Ab6342s00ServiceImpl  
 * 
 *  
 */

@Service(value = "otrasDependenciasViviendaService")
public class OtrasDependenciasViviendaServiceImpl implements OtrasDependenciasViviendaService {

	@Autowired
	private OtrasDependenciasViviendaDao ab6342s00Dao;

	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;

	/**
	 * Inserts a single row in the Ab6342s00 table.
	 *
	 * @param ab6342s00
	 *            Ab6342s00
	 * @return Ab6342s00
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OtrasDependenciasVivienda add(OtrasDependenciasVivienda ab6342s00) {
		return this.ab6342s00Dao.add(ab6342s00);
	}

	/**
	 * Updates a single row in the Ab6342s00 table.
	 *
	 * @param ab6342s00
	 *            Ab6342s00
	 * @return Ab6342s00
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OtrasDependenciasVivienda update(OtrasDependenciasVivienda ab6342s00) {
		return this.ab6342s00Dao.update(ab6342s00);
	}

	/**
	 * Finds a single row in the Ab6342s00 table.
	 *
	 * @param ab6342s00
	 *            Ab6342s00
	 * @return Ab6342s00
	 */
	public OtrasDependenciasVivienda find(OtrasDependenciasVivienda ab6342s00) {
		return (OtrasDependenciasVivienda) this.ab6342s00Dao.find(ab6342s00);
	}

	/**
	 * Deletes a single row in the Ab6342s00 table.
	 *
	 * @param ab6342s00
	 *            Ab6342s00
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(OtrasDependenciasVivienda ab6342s00) {
		this.ab6342s00Dao.remove(ab6342s00);
	}

	/**
	 * Finds a list of rows in the Ab6342s00 table.
	 *
	 * @param ab6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Ab6342s00>
	 */
	public List<OtrasDependenciasVivienda> findAll(OtrasDependenciasVivienda ab6342s00,
			JQGridRequestDto jqGridRequestDto) {
		return (List<OtrasDependenciasVivienda>) this.ab6342s00Dao.findAll(ab6342s00, jqGridRequestDto);
	}

	/**
	 * Finds rows in the Ab6342s00 table using like.
	 *
	 * @param ab6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Ab6342s00>
	 */
	public List<OtrasDependenciasVivienda> findAllLike(OtrasDependenciasVivienda ab6342s00,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<OtrasDependenciasVivienda>) this.ab6342s00Dao.findAllLike(ab6342s00, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Ab6342s00 table.
	 *
	 * @param filterAb6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(OtrasDependenciasVivienda filterAb6342s00, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.ab6342s00Dao.removeMultiple(filterAb6342s00, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the Ab6342s00 table.
	 *
	 * @param filterAb6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Ab6342s00>
	 */
	public JQGridResponseDto<OtrasDependenciasVivienda> filter(OtrasDependenciasVivienda filterAb6342s00,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<OtrasDependenciasVivienda> listaAb6342s00 = this.ab6342s00Dao.findAllLike(filterAb6342s00,
				jqGridRequestDto, false);
		Long recordNum = this.ab6342s00Dao
				.findAllLikeCount(filterAb6342s00 != null ? filterAb6342s00 : new OtrasDependenciasVivienda(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<OtrasDependenciasVivienda>> reorderSelection = this.ab6342s00Dao
					.reorderSelection(filterAb6342s00, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<OtrasDependenciasVivienda>(jqGridRequestDto, recordNum, listaAb6342s00,
					reorderSelection);
		}

		for (OtrasDependenciasVivienda otrasDependenciasVivienda : listaAb6342s00) {

			if (otrasDependenciasVivienda.getAccesible() != null) {

				if ("0".equals(otrasDependenciasVivienda.getAccesible())) {

					otrasDependenciasVivienda.setAccesible(
							appMessageSource.getMessage("negativo", null, LocaleContextHolder.getLocale()));

				} else {

					otrasDependenciasVivienda.setAccesible(
							appMessageSource.getMessage("afirmativo", null, LocaleContextHolder.getLocale()));

				}

			} else {

				otrasDependenciasVivienda
						.setAccesible(appMessageSource.getMessage("negativo", null, LocaleContextHolder.getLocale()));

			}

			if (otrasDependenciasVivienda.getEsCuartoBano() != null) {

				if ("0".equals(otrasDependenciasVivienda.getEsCuartoBano())) {

					otrasDependenciasVivienda.setEsCuartoBano(
							appMessageSource.getMessage("negativo", null, LocaleContextHolder.getLocale()));

				} else {

					otrasDependenciasVivienda.setEsCuartoBano(
							appMessageSource.getMessage("afirmativo", null, LocaleContextHolder.getLocale()));

				}

			} else {

				otrasDependenciasVivienda.setEsCuartoBano(
						appMessageSource.getMessage("negativo", null, LocaleContextHolder.getLocale()));

			}
		}

		return new JQGridResponseDto<OtrasDependenciasVivienda>(jqGridRequestDto, recordNum, listaAb6342s00);
	}

	/**
	 * Searches rows in the Ab6342s00 table.
	 *
	 * @param filterAb6342s00
	 *            Ab6342s00
	 * @param searchAb6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Ab6342s00>>
	 */
	public List<TableRowDto<OtrasDependenciasVivienda>> search(OtrasDependenciasVivienda filterAb6342s00,
			OtrasDependenciasVivienda searchAb6342s00, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.ab6342s00Dao.search(filterAb6342s00, searchAb6342s00, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Ab6342s00 table.
	 *
	 * @param filterAb6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(OtrasDependenciasVivienda filterAb6342s00, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.ab6342s00Dao.reorderSelection(filterAb6342s00, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Ab6342s00 table.
	 *
	 * @param filterAb6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Ab6342s00>>
	 */
	public JQGridResponseDto<JerarquiaDto<OtrasDependenciasVivienda>> jerarquia(
			OtrasDependenciasVivienda filterAb6342s00, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<OtrasDependenciasVivienda>> listaAb6342s00 = this.ab6342s00Dao
				.findAllLikeJerarquia(filterAb6342s00, jqGridRequestDto);
		Long recordNum = this.ab6342s00Dao.findAllLikeCountJerarquia(filterAb6342s00, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<OtrasDependenciasVivienda>>(jqGridRequestDto, recordNum,
				listaAb6342s00);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Ab6342s00 table.
	 *
	 * @param filterAb6342s00
	 *            Ab6342s00
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Ab6342s00>>
	 */
	public JQGridResponseDto<JerarquiaDto<OtrasDependenciasVivienda>> jerarquiaChildren(
			OtrasDependenciasVivienda filterAb6342s00, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<OtrasDependenciasVivienda>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<OtrasDependenciasVivienda>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.ab6342s00Dao.findAllChild(filterAb6342s00, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
